// CSGTedlg.h : header file
// This contains the definition of the main dialog class.  Included in this
// are the instantiations of the two CSG OLE Interface object as well
// as our reply object.

#include "csgole.h"
#include "replycla.h"
#include "CSGParam.h"

/////////////////////////////////////////////////////////////////////////////
// CCSGTestCDlg dialog

class CCSGTestCDlg : public CDialog
   {
   // Construction
   public:
	   CCSGTestCDlg(CWnd* pParent = NULL);	// standard constructor

      // Dialog Data
	   //{{AFX_DATA(CCSGTestCDlg)
	enum { IDD = dlgMain };
   	CEdit     mReturnCodeControl;
	   CEdit	    mReplySubstatusControl;
   	CEdit	    mReplyStatusControl;
	   CEdit	    mReceiveTextControl;
	   CButton	 mLoopControl;
	   CComboBox mCallControl;
	   CString	 mSendText;
	   CString	 mReceiveText;
      BOOL	    mDelay;
	   CString	 mPathmon;
	   CString	 mServer;
	   int		 mOption;
	   BOOL	    mWaited;
	   CString	 mCSGName;
	//}}AFX_DATA

	   // ClassWizard generated virtual function overrides
	   //{{AFX_VIRTUAL(CCSGTestCDlg)
	   protected:
	   virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	   //}}AFX_VIRTUAL

   // Implementation
   protected:
	   HICON          m_hIcon;
	   long           OptionSelected;
      _CSGClass      CSGRequest;             // Object for passing requests to CSG 
	   _CSGStatsClass CSGStats;               // Object for displaying interface stats
      ReplyClass     MyReplyObject;          // Instance for receiving replies from CSG
      
      short          DoSend(long OptionSelected, CSGParamsClass *Params, CSGParamsClass *TParams);   // To do send
      // Generated message map functions
	   //{{AFX_MSG(CCSGTestCDlg)
	   virtual BOOL OnInitDialog();
	   afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	   afx_msg void OnPaint();
	   afx_msg HCURSOR OnQueryDragIcon();
	   afx_msg void OncmdSend();
	   afx_msg void OncmdExit();
	   afx_msg void OnoptCSGSend();
	   afx_msg void OnoptSRVSend();
	   afx_msg void OnoptSSGSend();
	   afx_msg void OnoptSSGSendListdev();
	   afx_msg void OnoptSSGSendPrivate();
	   afx_msg void OnoptSSGSendShare();
	   afx_msg void OnoptSSGSendStatus();
	   afx_msg void OnoptUseDropdown();
	   afx_msg void OncmdStats();
	afx_msg void OncmdAbout();
	//}}AFX_MSG
	   DECLARE_MESSAGE_MAP()
   };  // class CCSGTestCDlg

// ***** End of file CSGTedlg.h *****
