// csgole.h
// This file containes the class declarations for interfacing with the OLE CSG.  
// There are two classes defined:
//    _CSGClass
//    This is the main OLE interface to CSG services.  Client applications utilize
//    this mechanism by instantiating objects of this class, and invoking the
//    appropriate methods to pass data to the CSG and host.  Both waited and
//    nowaited variants of all calls are supported.  Note that when calling
//    these methods, all parameters are required.  This differs from VB, in which
//    some of the parameters are optional.
//
//    _CSGStatsClass   
//    This class is used to provide an interface to request/reply statistics.
//    Invoking the ShowStats method will cause a modal dialog box to be displayed 
//    detailing request and response history, error information, etc.  Note
//    that no data is returned to the client app.  


/////////////////////////////////////////////////////////////////////////////
// Machine generated IDispatch wrapper class(es) created with ClassWizard
/////////////////////////////////////////////////////////////////////////////


// _CSGClass wrapper class

class _CSGClass : public COleDispatchDriver
   {
   // Constructors
   public:
      _CSGClass() {}		// Calls COleDispatchDriver default constructor
      _CSGClass(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
      _CSGClass(const _CSGClass& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

   // Attributes
   public:

   // Operations
   public:
      unsigned long AddRef();
      unsigned long Release();
	long Cancel(BSTR* ClientName, VARIANT* RequestID, VARIANT* CSGName);
	short SSGSend(LPDISPATCH* ClientObject, BSTR* ClientName, BSTR* Message, VARIANT* CSGName, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, VARIANT* ClientContext, VARIANT* RequestID);
	short SSGSendWait(short* Status, short* SubStatus, BSTR* ClientName, BSTR* Message, VARIANT* CSGName, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, VARIANT* ClientContext, VARIANT* Timeout);
	short SSGSendPrivate(LPDISPATCH* ClientObject, BSTR* ClientName, BSTR* CI, BSTR* Message, VARIANT* CSGName, VARIANT* CacheIndex, VARIANT* Tag, VARIANT* Term, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, VARIANT* ClientContext, 
		VARIANT* RequestID);
	short SSGSendPrivateWait(short* Status, short* SubStatus, BSTR* ClientName, BSTR* CI, BSTR* Message, VARIANT* CSGName, VARIANT* CacheIndex, VARIANT* Tag, VARIANT* Term, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, 
		VARIANT* ClientContext, VARIANT* Timeout);
	short SSGSendShare(LPDISPATCH* ClientObject, BSTR* ClientName, BSTR* CI, BSTR* Message, VARIANT* CSGName, VARIANT* AgeGen, VARIANT* CacheIndex, VARIANT* Tag, VARIANT* Term, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, 
		VARIANT* ClientContext, VARIANT* RequestID);
	short SSGSendShareWait(short* Status, short* SubStatus, BSTR* ClientName, BSTR* CI, BSTR* Message, VARIANT* CSGName, VARIANT* AgeGen, VARIANT* CacheIndex, VARIANT* Tag, VARIANT* Term, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, 
		VARIANT* ClientContext, VARIANT* Timeout);
	short SSGSendStatus(LPDISPATCH* ClientObject, BSTR* ClientName, BSTR* Message, VARIANT* CSGName, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, VARIANT* ClientContext, VARIANT* RequestID);
	short SSGSendStatusWait(short* Status, short* SubStatus, BSTR* ClientName, BSTR* Message, VARIANT* CSGName, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, VARIANT* ClientContext, VARIANT* Timeout);
	short SSGSendListdev(LPDISPATCH* ClientObject, BSTR* ClientName, BSTR* Message, VARIANT* CSGName, VARIANT* CacheIndex, VARIANT* Tag, VARIANT* Term, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, VARIANT* ClientContext, 
		VARIANT* RequestID);
	short SSGSendListdevWait(short* Status, short* SubStatus, BSTR* ClientName, BSTR* Message, VARIANT* CSGName, VARIANT* CacheIndex, VARIANT* Tag, VARIANT* Term, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, VARIANT* ClientContext, 
		VARIANT* Timeout);
	short SRVSend(LPDISPATCH* ClientObject, BSTR* ClientName, BSTR* Message, VARIANT* CSGName, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, VARIANT* ClientContext, VARIANT* RequestID);
	short SRVSendWait(short* Status, short* SubStatus, BSTR* ClientName, BSTR* Message, VARIANT* CSGName, VARIANT* ReplayKey, VARIANT* Pathmon, VARIANT* Server, VARIANT* ClientContext, VARIANT* Timeout);
	short CSGSend(LPDISPATCH* ClientObject, BSTR* ClientName, BSTR* Message, VARIANT* CSGName, VARIANT* ClientContext, VARIANT* RequestID);
	short CSGSendWait(short* Status, short* SubStatus, BSTR* ClientName, BSTR* Message, VARIANT* CSGName, VARIANT* ClientContext, VARIANT* Timeout);
	short StartSession(BSTR* UserID, BSTR* Password, BSTR* SSGID, BSTR* SSGCtlNode, short* SubStatus, VARIANT* CSGName);
	short EndSession(short* SubStatus, VARIANT* CSGName);
	BOOL CSGStatus(VARIANT* CSGName, VARIANT* RequestTag, VARIANT* UserID, VARIANT* SSGID, VARIANT* QDepth, VARIANT* RecordReplayState);

   };  // _CSGClass


/////////////////////////////////////////////////////////////////////////////
// _CSGStatsClass wrapper class

class _CSGStatsClass : public COleDispatchDriver
   {
   public:
   	_CSGStatsClass() {}		// Calls COleDispatchDriver default constructor
	   _CSGStatsClass(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	   _CSGStatsClass(const _CSGStatsClass& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

   // Attributes
   public:

   // Operations
   public:
   	unsigned long AddRef();
	   unsigned long Release();
	   void ResetStats();
	   void ShowStats();
   };  // _CSGStatsClass

// ***** End of file csgole.h *****/////////////////////////////////////////////////////////////////////////////
